Imports System.Windows.Forms
Imports System.Drawing

Public Class ScrollBar
    Implements IDisposable 'Inherit from IDisposable if you need Basic4ppc to free resources when the application is closed.

    Private WithEvents sb As System.Windows.Forms.ScrollBar 'The "real" object.
    Public Event ValueChanged As EventHandler 'The event handler name must match the event name.
    Private eventObject() As Object 'One object[] for each event (one event here).

    Sub New(ByVal FormName As Control, ByVal Left As Int32, ByVal Top As Int32, ByVal Width As Int32, ByVal Height As Int32, ByVal IsVertical As Boolean)
        If IsVertical Then
            sb = New VScrollBar
        Else
            sb = New HScrollBar
        End If
        sb.Left = Left
        sb.Top = Top
        sb.Width = Width
        sb.Height = Height
        FormName.Controls.Add(sb)

        'This is the object that will pass with the event.
        'It must be in that format exactly.
        eventObject = New Object() {Me, "ValueChanged"}
    End Sub

    Private Sub sb_ValueChanged(ByVal sender As Object, ByVal e As EventArgs) Handles sb.ValueChanged
        RaiseEvent ValueChanged(eventObject, Nothing)
    End Sub

    Public Function FunctionExample(ByVal a As Int32, ByVal b As Int32) As Int32
        Return a + b
    End Function
    '//Use properties to allow syntax like: bar.Height = 50 OR x = bar.Height
    Public Property Value() As Int32
        Get
            Return sb.Value
        End Get
        Set(ByVal Value As Int32)
            sb.Value = Value
        End Set
    End Property

    Public Property Height() As Int32
        Get
            Return sb.Height
        End Get
        Set(ByVal Value As Int32)
            sb.Value = Value
        End Set
    End Property
    Public ReadOnly Property DLLVersion() As Double
        Get
            Return 1.0
        End Get
    End Property

    Public Sub Dispose() Implements System.IDisposable.Dispose
        If Not sb Is Nothing Then
            sb.Dispose()
        End If
    End Sub
End Class
